| API Docs for SAX and DOM |

Main Page Class Hierarchy Alphabetical List Compound List File List Compound Members File Members

# XMLPlatformUtils Class Reference

Utilities that must be implemented in a platform-specific way. More...

Collaboration diagram for XMLPlatformUtils:

[legend]
List of all members.

## Static Public Methods

size_t | alignPointerForNewBlockAllocation (size_t ptrSize)
| Aligns the specified pointer per platform block allocation requirements. More...
Initialization amd Panic methods
void | Initialize (const char *const locale=XMLUni::fgXercescDefaultLocale, const char *const nlsHome=0, PanicHandler *const panicHandler=0, MemoryManager *const memoryManager=0)
| Perform per-process parser initialization. More...
void | Terminate ()
| Perform per-process parser termination. More...
void | panic (const PanicHandler::PanicReasons reason)
| The panic mechanism. More...
File Methods
unsigned int | curFilePos (FileHandle theFile, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Get the current file position. More...
void | closeFile (FileHandle theFile, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Closes the file handle. More...
unsigned int | fileSize (FileHandle theFile, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Returns the file size. More...
FileHandle | openFile (const char *const fileName, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Opens the file. More...
FileHandle | openFile (const XMLCh *const fileName, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Opens a named file. More...
FileHandle | openFileToWrite (const char *const fileName, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Open a named file to write. More...
FileHandle | openFileToWrite (const XMLCh *const fileName, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Open a named file to write. More...
FileHandle | openStdInHandle (MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Opens the standard input as a file. More...
unsigned int | readFileBuffer (FileHandle theFile, const unsigned int toRead, XMLByte *const toFill, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Reads the file buffer. More...
void | writeBufferToFile (FileHandle const theFile, long toWrite, const XMLByte *const toFlush, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Writes the buffer to the file. More...
void | resetFile (FileHandle theFile, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Resets the file handle. More...
File System Methods
XMLCh * | getFullPath (const XMLCh *const srcPath, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Gets the full path from a relative path. More...
XMLCh * | getCurrentDirectory (MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Gets the current working directory. More...
bool | isAnySlash (XMLCh c)
| Check if a charater is a slash. More...
void | removeDotSlash (XMLCh *const srcPath, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Remove occurences of the pair of dot slash. More...
void | removeDotDotSlash (XMLCh *const srcPath, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Remove occurences of the dot dot slash. More...
bool | isRelative (const XMLCh *const toCheck, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Determines if a path is relative or absolute. More...
XMLCh * | weavePaths (const XMLCh *const basePath, const XMLCh *const relativePath, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| Utility to join two paths. More...
Timing Methods
unsigned long | getCurrentMillis ()
| Gets the system time in milliseconds. More...
Mutex Methods
void | closeMutex (void *const mtxHandle)
| Closes a mutex handle. More...
void | lockMutex (void *const mtxHandle)
| Locks a mutex handle. More...
void * | makeMutex ()
| Make a new mutex. More...
void | unlockMutex (void *const mtxHandle)
| Unlocks a mutex. More...
External Message Support
XMLMsgLoader * | loadMsgSet (const XMLCh *const msgDomain)
| Loads the message set from among the available domains. More...
Miscellaneous synchronization methods
void * | compareAndSwap (void **toFill, const void *const newValue, const void *const toCompare)
| Conditionally updates or returns a single word variable atomically. More...
Atomic Increment and Decrement
int | atomicIncrement (int &location)
| Increments a single word variable atomically. More...
int | atomicDecrement (int &location)
| Decrements a single word variable atomically. More...
NEL Character Handling
void | recognizeNEL (bool state, MemoryManager *const manager=XMLPlatformUtils::fgMemoryManager)
| This function enables the recognition of NEL(0x85) char and LSEP (0x2028) as newline chars which is disabled by default. More...
bool | isNELRecognized ()
| Return the value of fgNEL flag. More...
Strict IANA Encoding Checking
void | strictIANAEncoding (const bool state)
| This function enables/disables strict IANA encoding names checking. More...
bool | isStrictIANAEncoding ()
| Returns whether a strict IANA encoding name check is enabled or disabled. More...

## Static Public Attributes

Public Static Data
XMLNetAccessor * | fgNetAccessor
| The network accessor. More...
XMLTransService * | fgTransService
| The transcoding service. More...
PanicHandler * | fgUserPanicHandler
| The Panic Handler. More...
PanicHandler * | fgDefaultPanicHandler
| The Panic Handler. More...
MemoryManager * | fgMemoryManager
| The configurable memory manager. More...
MemoryManager * | fgArrayMemoryManager
| The array-allocating memory manager. More...
XMLMutex * | fgAtomicMutex

## Detailed Description

Utilities that must be implemented in a platform-specific way.

This class contains methods that must be implemented in a platform specific manner. The actual implementations of these methods are available in the per-platform files indide `src/util/Platforms` .

## Member Function Documentation

size_t XMLPlatformUtils::alignPointerForNewBlockAllocation | ( | size_t | ptrSize | ) | `[static]`

| Aligns the specified pointer per platform block allocation requirements. The results of this function may be altered by defining XML_PLATFORM_NEW_BLOCK_ALIGNMENT.

int XMLPlatformUtils::atomicDecrement | ( | int & | location | ) | `[static]`

Decrements a single word variable atomically.

This must be implemented by the per-platform driver. The atomicDecrement subroutine increments one word in a single atomic operation. This operation is useful when a counter variable is shared between several threads or processes. When updating such a counter variable, it is important to make sure that the fetch, update, and store operations occur atomically (are not interruptible).

Parameters:

  location | Specifies the address of the word variable to be decremented.

Returns:
  The function return value is positive if the result of the operation was positive. Zero if the result of the operation was zero. Negative if the result of the operation was negative. Except for the zero case, the value returned may differ from the actual result of the operation - only the sign and zero/nonzero state is guaranteed to be correct.

int XMLPlatformUtils::atomicIncrement | ( | int & | location | ) | `[static]`

Increments a single word variable atomically.

This must be implemented by the per-platform driver. The atomicIncrement subroutine increments one word in a single atomic operation. This operation is useful when a counter variable is shared between several threads or processes. When updating such a counter variable, it is important to make sure that the fetch, update, and store operations occur atomically (are not interruptible).

Parameters:

  location | Specifies the address of the word variable to be incremented.

Returns:
  The function return value is positive if the result of the operation was positive. Zero if the result of the operation was zero. Negative if the result of the operation was negative. Except for the zero case, the value returned may differ from the actual result of the operation - only the sign and zero/nonzero state is guaranteed to be correct.

void XMLPlatformUtils::closeFile | ( | FileHandle | theFile,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Closes the file handle.

This must be implemented by the per-platform driver, which should use local file services to close the passed file handle, and to destroy the passed file handle and any allocated data or system resources it contains.

Parameters:

  theFile | The file handle to close

void XMLPlatformUtils::closeMutex | ( | void *const | mtxHandle | ) | `[static]`

Closes a mutex handle.

Each per-platform driver must implement this. Only it knows what the actual content of the passed mutex handle is.

Parameters:

  mtxHandle | The mutex handle that you want to close

void* XMLPlatformUtils::compareAndSwap | ( | void ** | toFill,
|  | const void *const | newValue,
|  | const void *const | toCompare
| ) | `[static]`

Conditionally updates or returns a single word variable atomically.

This must be implemented by the per-platform driver. The compareAndSwap subroutine performs an atomic operation which compares the contents of a single word variable with a stored old value. If the values are equal, a new value is stored in the single word variable and TRUE is returned; otherwise, the old value is set to the current value of the single word variable and FALSE is returned.

The compareAndSwap subroutine is useful when a word value must be updated only if it has not been changed since it was last read.

Note: The word containing the single word variable must be aligned on a full word boundary.

Parameters:

  toFill | Specifies the address of the single word variable
  newValue | Specifies the new value to be conditionally assigned to the single word variable.
  toCompare | Specifies the address of the old value to be checked against (and conditionally updated with) the value of the single word variable.

Returns:
  Returns the new value assigned to the single word variable

unsigned int XMLPlatformUtils::curFilePos | ( | FileHandle | theFile,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Get the current file position.

This must be implemented by the per-platform driver, which should use local file services to deterine the current position within the passed file.

Since the file API provided here only reads, if the host platform supports separate read/write positions, only the read position is of any interest, and hence should be the one returned.

Parameters:

  theFile | The file handle

unsigned int XMLPlatformUtils::fileSize | ( | FileHandle | theFile,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Returns the file size.

This must be implemented by the per-platform driver, which should use local file services to determine the current size of the file represented by the passed handle.

Parameters:

  theFile | The file handle whose size you want

Returns:
  Returns the size of the file in bytes

XMLCh* XMLPlatformUtils::getCurrentDirectory | ( | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager | ) | `[static]`

Gets the current working directory.

This must be implemented by the per-platform driver. It returns the current working directory is.

Returns:
  Returns the current working directory. This is dyanmically allocated and must be deleted by the caller when its no longer needed! The memory returned will be allocated using the static memory manager, if users do not supply a memory manager. Users then need to make sure to use either the default or user specific memory manager to deallocate the memory.

unsigned long XMLPlatformUtils::getCurrentMillis | ( |  | ) | `[static]`

Gets the system time in milliseconds.

This must be implemented by the per-platform driver, which should use local services to return the current value of a running millisecond timer. Note that the value returned is only as accurate as the millisecond time of the underyling host system.

Returns:
  Returns the system time as an unsigned long

XMLCh* XMLPlatformUtils::getFullPath | ( | const XMLCh *const | srcPath,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Gets the full path from a relative path.

This must be implemented by the per-platform driver. It should complete a relative path using the 'current directory', or whatever the local equivalent of a current directory is. If the passed source path is actually fully qualified, then a straight copy of it will be returned.

Parameters:

  srcPath | The path of the file for which you want the full path
  manager | Pointer to the memory manager to be used to allocate objects.

Returns:
  Returns the fully qualified path of the file name including the file name. This is dyanmically allocated and must be deleted by the caller when its no longer needed! The memory returned will beallocated using the static memory manager, if user do not supply a memory manager. Users then need to make sure to use either the default or user specific memory manager to deallocate the memory.

void XMLPlatformUtils::Initialize | ( | const char *const | locale = XMLUni::fgXercescDefaultLocale,
|  | const char *const | nlsHome = 0,
|  | PanicHandler *const | panicHandler = 0,
|  | MemoryManager *const | memoryManager = 0
| ) | `[static]`

Perform per-process parser initialization.

Initialization must be called first in any client code.

The locale is set iff the Initialize() is invoked for the very first time, to ensure that each and every message loaders, in the process space, share the same locale.

All subsequent invocations of Initialize(), with a different locale, have no effect on the message loaders, either instantiated, or to be instantiated.

To set to a different locale, client application needs to Terminate() (or multiple Terminate() in the case where multiple Initialize() have been invoked before), followed by Initialize(new_locale).

The default locale is "en_US".

nlsHome: user specified location where MsgLoader retrieves error message files. the discussion above with regard to locale, applies to this nlsHome as well.

panicHandler: application's panic handler, application owns this handler. Application shall make sure that the plugged panic handler persists through the call to XMLPlatformUtils::terminate().

memoryManager: plugged-in memory manager which is owned by user applications. Applications must make sure that the plugged-in memory manager persisit through the call to XMLPlatformUtils::terminate()

bool XMLPlatformUtils::isAnySlash | ( | XMLCh | c | ) | `[static]`

Check if a charater is a slash.

This must be implemented by the per-platform driver.

Parameters:

  c | the character to be examined

Returns:
  true if the character examined is a slash false otherwise

bool XMLPlatformUtils::isNELRecognized | ( |  | ) | `[static]`

| Return the value of fgNEL flag.

bool XMLPlatformUtils::isRelative | ( | const XMLCh *const | toCheck,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Determines if a path is relative or absolute.

This must be implemented by the per-platform driver, which should determine whether the passed path is relative or not. The concept of relative and absolute might be... well relative on different platforms. But, as long as the determination is made consistently and in coordination with the weavePaths() method, it should work for any platform.

Parameters:

  toCheck | The file name which you want to check

Returns:
  Returns true if the filename appears to be relative

bool XMLPlatformUtils::isStrictIANAEncoding | ( |  | ) | `[static]`

| Returns whether a strict IANA encoding name check is enabled or disabled.

XMLMsgLoader* XMLPlatformUtils::loadMsgSet | ( | const XMLCh *const | msgDomain | ) | `[static]`

Loads the message set from among the available domains.

The returned object must be dynamically allocated and the caller becomes responsible for cleaning it up.

Parameters:

  msgDomain | The message domain which you want to load

void XMLPlatformUtils::lockMutex | ( | void *const | mtxHandle | ) | `[static]`

Locks a mutex handle.

Each per-platform driver must implement this. Only it knows what the actual content of the passed mutex handle is.

Parameters:

  mtxHandle | The mutex handle that you want to lock

void* XMLPlatformUtils::makeMutex | ( |  | ) | `[static]`

| Make a new mutex. Each per-platform driver must implement this. Only it knows what the actual content of the passed mutex handle is. The returned handle pointer will be eventually passed to closeMutex() which is also implemented by the platform driver.

FileHandle XMLPlatformUtils::openFile | ( | const XMLCh *const | fileName,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Opens a named file.

This must be implemented by the per-platform driver, which should use local file services to open the passed file. If it fails, a null handle pointer should be returned.

Parameters:

  fileName | The string containing the name of the file

Returns:
  The file handle of the opened file

FileHandle XMLPlatformUtils::openFile | ( | const char *const | fileName,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Opens the file.

This must be implemented by the per-platform driver, which should use local file services to open passed file. If it fails, a null handle pointer should be returned.

Parameters:

  fileName | The string containing the name of the file

Returns:
  The file handle of the opened file

FileHandle XMLPlatformUtils::openFileToWrite | ( | const XMLCh *const | fileName,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Open a named file to write.

This must be implemented by the per-platform driver, which should use local file services to open the passed file. If it fails, a null handle pointer should be returned.

Parameters:

  fileName | The string containing the name of the file

Returns:
  The file handle of the opened file

FileHandle XMLPlatformUtils::openFileToWrite | ( | const char *const | fileName,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Open a named file to write.

This must be implemented by the per-platform driver, which should use local file services to open passed file. If it fails, a null handle pointer should be returned.

Parameters:

  fileName | The string containing the name of the file

Returns:
  The file handle of the opened file

FileHandle XMLPlatformUtils::openStdInHandle | ( | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager | ) | `[static]`

Opens the standard input as a file.

This must be implemented by the per-platform driver, which should use local file services to open a handle to the standard input. It should be a copy of the standard input handle, since it will be closed later!

Returns:
  The file handle of the standard input stream

void XMLPlatformUtils::panic | ( | const PanicHandler::PanicReasons | reason | ) | `[static]`

The panic mechanism.

If, during initialization, we cannot even get far enough along to get transcoding up or get message loading working, we call this method.

Each platform can implement it however they want. This method will delegate the panic handling to a user specified panic handler or in the absence of it, the default panic handler.

In case the default panic handler does not support a particular platform, the platform specific panic hanlding shall be implemented here .

Parameters:

  reason | The enumeration that defines the cause of the failure

unsigned int XMLPlatformUtils::readFileBuffer | ( | FileHandle | theFile,
|  | const unsigned int | toRead,
|  | XMLByte *const | toFill,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Reads the file buffer.

This must be implemented by the per-platform driver, which should use local file services to read up to 'toRead' bytes of data from the passed file, and return those bytes in the 'toFill' buffer. It is not an error not to read the requested number of bytes. When the end of file is reached, zero should be returned.

Parameters:

  theFile | The file handle to be read from.
  toRead | The maximum number of byte to read from the current position
  toFill | The byte buffer to fill

Returns:
  Returns the number of bytes read from the stream or file

void XMLPlatformUtils::recognizeNEL | ( | bool | state,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

This function enables the recognition of NEL(0x85) char and LSEP (0x2028) as newline chars which is disabled by default.

It is only called once per process. Once it is set, any subsequent calls will result in exception being thrown.

Note: 1. Turning this option on will make the parser non compliant to XML 1.0. 2. This option has no effect to document conforming to XML 1.1 compliant, which always recognize these two chars (0x85 and 0x2028) as newline characters.

void XMLPlatformUtils::removeDotDotSlash | ( | XMLCh *const | srcPath,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Remove occurences of the dot dot slash.

To remove the sequence, slash dot dot slash and its preceding path segment if and only if the preceding path segment is not slash dot dot slash.

Parameters:

  srcPath | The path for which you want to remove the slash dot dot slash sequence and its preceding path segment.

Returns:

void XMLPlatformUtils::removeDotSlash | ( | XMLCh *const | srcPath,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Remove occurences of the pair of dot slash.

To remove the sequence, dot slash if it is part of the sequence, slash dot slash.

Parameters:

  srcPath | The path for which you want to remove the dot slash sequence.

Returns:

void XMLPlatformUtils::resetFile | ( | FileHandle | theFile,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Resets the file handle.

This must be implemented by the per-platform driver which will use local file services to reset the file position to the start of the the file.

Parameters:

  theFile | The file handle that you want to reset

void XMLPlatformUtils::strictIANAEncoding | ( | const bool | state | ) | `[static]`

This function enables/disables strict IANA encoding names checking.

The strict checking is disabled by default.

Parameters:

  state | If true, a strict IANA encoding name check is performed, otherwise, no checking.

void XMLPlatformUtils::Terminate | ( |  | ) | `[static]`

| Perform per-process parser termination. The termination call is currently optional, to aid those dynamically loading the parser to clean up before exit, or to avoid spurious reports from leak detectors.

void XMLPlatformUtils::unlockMutex | ( | void *const | mtxHandle | ) | `[static]`

Unlocks a mutex.

Each per-platform driver must implement this. Only it knows what the actual content of the passed mutex handle is.

Note that, since the underlying system synchronization services are used, Xerces cannot guarantee that lock/unlock operations are correctly enforced on a per-thread basis or that incorrect nesting of lock/unlock operations will be caught.

Parameters:

  mtxHandle | The mutex handle that you want to unlock

XMLCh* XMLPlatformUtils::weavePaths | ( | const XMLCh *const | basePath,
|  | const XMLCh *const | relativePath,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Utility to join two paths.

This must be implemented by the per-platform driver, and should weave the relative path part together with the base part and return a new path that represents this combination.

If the relative part turns out to be fully qualified, it will be returned as is. If it is not, then it will be woven onto the passed base path, by removing one path component for each leading "../" (or whatever is the equivalent in the local system) in the relative path.

Parameters:

  basePath | The string containing the base path
  relativePath | The string containing the relative path

Returns:
  Returns a string containing the 'woven' path. It should be dynamically allocated and becomes the responsibility of the caller to delete.

void XMLPlatformUtils::writeBufferToFile | ( | FileHandle const | theFile,
|  | long | toWrite,
|  | const XMLByte *const | toFlush,
|  | MemoryManager *const | manager = XMLPlatformUtils::fgMemoryManager
| ) | `[static]`

Writes the buffer to the file.

This must be implemented by the per-platform driver, which should use local file services to write up to 'toWrite' bytes of data to the passed file. Unless exception raised by local file services, 'toWrite' bytes of data is to be written to the passed file.

Parameters:

  theFile | The file handle to be written to.
  toWrite | The maximum number of byte to write from the current position
  toFlush | The byte buffer to flush

Returns:
  void

## Member Data Documentation

MemoryManager* XMLPlatformUtils::fgArrayMemoryManager`[static]`

| The array-allocating memory manager. This memory manager always allocates memory by calling the global new[] operator. It may be used to allocate memory where such memory needs to be deletable by calling delete []. Since this allocator is always guaranteed to do the same thing there is no reason, nor facility, to override it.

XMLMutex* XMLPlatformUtils::fgAtomicMutex`[static]`

PanicHandler* XMLPlatformUtils::fgDefaultPanicHandler`[static]`

| The Panic Handler. This is the default panic handler.

MemoryManager* XMLPlatformUtils::fgMemoryManager`[static]`

| The configurable memory manager. This is the pluggable memory manager. If it is not provided by an application, a default implementation is used.

XMLNetAccessor* XMLPlatformUtils::fgNetAccessor`[static]`

The network accessor.

This is provided by the per-platform driver, so each platform can choose what actual implementation it wants to use. The object must be dynamically allocated.

Note that you may optionally, if your platform driver does not install a network accessor, set it manually from your client code after calling Initialize(). This works because this object is not required during initialization, and only comes into play during actual XML parsing.

XMLTransService* XMLPlatformUtils::fgTransService`[static]`

The transcoding service.

This is provided by the per platform driver, so each platform can choose what implemenation it wants to use. When the platform independent initialization code needs to get a transcoding service object, it will call `makeTransService()` to ask the per-platform code to create one. Only one transcoding service object is reqeusted per-process, so it is shared and synchronized among parser instances within that process.

PanicHandler* XMLPlatformUtils::fgUserPanicHandler`[static]`

| The Panic Handler. This is the application provided panic handler.

The documentation for this class was generated from the following file:

- PlatformUtils.hpp

Copyright © 2004 The Apache Software Foundation. All Rights Reserved.